#include "motor.h"
#include "pwm.h"
#define SPEED_FILTER_NUM 5


int pwm_duty=0;
uchar CapState=0,last_CapState;
uchar motor_state=MOTOR_STOP;
uchar MotorDir = 0;

uint counter13=0,counter13_record = 0;
uchar T13H_record=0,T13L_record;
uchar stop_flag = 0;
unsigned int speed_target = 1500;

unsigned long speed_count[SPEED_FILTER_NUM];
unsigned char i_store=0;
uchar counter_PID=0,PID_flag=0;
uint counter_1s=0;
void gpio_init(void)
{
    ANSL = 0Xff;  //PA345ΪģȽ˿
    ANSH = 0XFF;
	ANSL0 = 0;    //PA0 ADC
	ANSH5 = 0;    //PB5 AN12 ģ LVDT
	/**********************˿*****************************/
	PBT4 = 1;  
	PBPU4 =1;
	KIE = 1;  //ʹKINT
	KMSK0=0;  //KINT 0
	KMSK1=0;
	KMSK2=0;
	KMSK3=0;
	/***************************************************/
	PAT3=1;
	PAT4=1;
	PAT5=1;
	PAPU3 =1;
	PAPU4 =1;
	PAPU5 =1;

	PHASE_U_H = 1;			//PINʼ
	PHASE_U_H_Dir = 0;
	PHASE_U_L = 1;
	PHASE_U_L_Dir = 0;
	PHASE_V_H = 1;
	PHASE_V_H_Dir = 0;
	PHASE_V_L = 1;
	PHASE_V_L_Dir = 0;
	PHASE_W_H = 1;
	PHASE_W_H_Dir = 0;
	PHASE_W_L = 1;
	PHASE_W_L_Dir = 0;

	DRV_EN_Dir = 0;
	DRV_EN = 1;             //ʹIR2136
}


uint8  startMotor(void)
{
	uint16 i = 0;
	uchar j=0;
	uint32 delayMs1 = 12000;	
	uint MotorPhase=0;
	
	do{
		if(MotorDir == 0)
			phase_change_H(MotorPhase);
		else	
			phase_change_H(5-MotorPhase);
		for(i=0;i<delayMs1;i++)
		{
			NOP();
		}
		MotorPhase++;
		MotorPhase %= 6; 
		delayMs1 -= delayMs1/15+1;
		set_PWM_Duty(pwm_value_table[j++]);
		if(j>=48)
			j=48;
	}while (delayMs1 > START_TIME);	
	//while(1)
	//{
		//dealy(10);
		//phase_change_H(MotorPhase);
		//MotorPhase++;
		//MotorPhase %= 6; 
	//}
	//set_PWM_Duty(900);
	ACP2IE = 1;
	ACP3IE = 1;
	ACP5IE = 1;
	motor_state=MOTOR_RUN;
	return SUCCESS;

}


float get_speed(void)
{
		static float last_speed = 0;
		float speedw;
		unsigned long sum=0;
		unsigned char i=0,j=0;
		if(stop_flag == 1)
			return 0;
		for(i=0;i<SPEED_FILTER_NUM;i++)
		{
			if((speed_count[i]>6000) && (speed_count[i]<100000))
			{
				j++;
				sum+=speed_count[i];
			}
		}
		if(j<1)
		{
			speedw = last_speed;
			return 0;
		}
		sum = sum/j;
		speedw = (30000000.0/(float)sum);
		last_speed = speedw;
		return speedw;
}

void change_step(void)
{	
	CapState = (uchar)C2OUT|(uchar)C3OUT<<1|(uchar)C5OUT<<2;
	if(last_CapState != CapState)
	{
		if(MotorDir == 0)
			switch(CapState)
			{
				case 1:phase_change_H_I(1);break;
				case 2:phase_change_H_I(3);	break;
				case 3:phase_change_H_I(2);break;
				case 4:phase_change_H_I(5);break;
				case 5:phase_change_H_I(0);break;
				case 6:phase_change_H_I(4);
				stop_flag = 0;
				T13H_record = T13H;
				T13L_record = T13L;

				speed_count[i_store++] = (counter13*1000)+T13L_record+((uint)T13H_record<<8);
				if(i_store>=SPEED_FILTER_NUM)
					i_store=0;
				T13L = 0;
				T13H =0;
				counter13 = 0;
				break;
				default:break;
			}
		else
			switch(CapState)
			{
				//case 1:phase_change_H_I(0);break;
				//case 2:phase_change_H_I(2);break;
				//case 3:phase_change_H_I(1);break;
				//case 4:phase_change_H_I(4);break;
				//case 5:phase_change_H_I(5);break;
				//case 6:phase_change_H_I(2);

				case 1:phase_change_H_I(0);break;
				case 2:phase_change_H_I(2);break;
				case 3:phase_change_H_I(1);break;
				case 4:phase_change_H_I(4);break;
				case 5:phase_change_H_I(5);break;
				case 6:phase_change_H_I(3);

				stop_flag = 0;
				T13H_record = T13H;
				T13L_record = T13L;

				speed_count[i_store++] = (counter13*1000)+T13L_record+((uint)T13H_record<<8);
				if(i_store>=SPEED_FILTER_NUM)
					i_store=0;

				T13L = 0;
				T13H =0;
				counter13 = 0;
				break;
				default:break;
			}
	}
	last_CapState = CapState;
}

void isr(void) interrupt
{
	unsigned char Rx_value =0;
	unsigned char temp_pb4 =0;
	if(ACP2IE && ACP2IF)   //U
	{ 	   		
		ACP2IF = 0;	
		change_step();
	}
	else if(ACP3IE && ACP3IF)  //V
	{
		ACP3IF = 0;
		change_step();
	}
	else if(ACP5IE && ACP5IF)  //W
	{

		ACP5IF = 0;
		change_step();
	}
	if(T13IE && T13IF)
	{
		T13IF =0;
		counter13++;
		counter_PID++;
		counter_1s++;
		if(counter13 >=200) //0.2
		{
			counter13 =0;
			stop_flag = 1;
		}
		if(counter_PID>=20) //20msһPID
		{
			PID_flag = 1;
			counter_PID =0;
		}
	}
	if(RXIF && RXIE)
	{
		RXIF = 0;
		Rx_value = RXB;
		//TXB = Rx_value;
		//while(!TRMT);
		if(Rx_value<=100)
		{
			speed_target = Rx_value*25;
			speed_target = 1500+speed_target;
			//if(speed_target<1500)
				//speed_target =1500;
		}
		else if((Rx_value == UART_POSI_FLAG)&&(motor_state != MOTOR_VPROTECT)&&(motor_state != MOTOR_IPROTECT)) 
		{
			if(MotorDir == 0)
			{
				motor_state=MOTOR_CHANGEDIR;
				MotorDir = 1;
			}
		}
		else if((Rx_value == UART_MEG_FLAG)&&(motor_state != MOTOR_VPROTECT)&&(motor_state != MOTOR_IPROTECT) )
		{
			if(MotorDir == 1)
			{
				motor_state=MOTOR_CHANGEDIR;
				MotorDir = 0;
			}
		}
		else if((Rx_value == UART_STOP_FLAG)&&(motor_state != MOTOR_VPROTECT)&&(motor_state != MOTOR_IPROTECT)  )
			motor_state=MOTOR_STOP;
		else if((Rx_value == UART_START_FLAG) && ((motor_state == MOTOR_STOP)||(motor_state == MOTOR_IPROTECT)))
			motor_state=MOTOR_START;
	}

	else if(KIE && KIF)
	{
		temp_pb4 = PB4;
		KIF = 0;
	    motor_state = MOTOR_IPROTECT;
	}
}
