#include <hic.h>
#include "typedef.h"

#define UART_STOP_FLAG 200
#define UART_START_FLAG 201
#define UART_POSI_FLAG 202
#define UART_MEG_FLAG 203

#define DRV_EN_Dir PBT6
#define DRV_EN PB6

#define NOP()       __Asm nop
#define CLRWDT()    __Asm CWDT
#define DI()        INTG &=0X7F;          //GIE_GIEH=0; PEIE_GIEL=0;
#define EI()        INTG |=0X80;          //GIE_GIEH=1; PEIE_GIEL=0;
#define SUCCESS 1
#define FALSE 0
#define GETSPEED 0
#define START_TIME 500

typedef enum 
{
	MOTOR_START = 0,
	MOTOR_RUN = 1,
	MOTOR_STOP = 2,
	MOTOR_CHANGEDIR= 3,
	MOTOR_VPROTECT = 4,
	MOTOR_IPROTECT =5,
}run_state;

const uint pwm_value_table[50]={
	124	 ,
	124	 ,
	130	 ,
	130	 ,
	130	 ,
	136	 ,
	136	 ,
	142	 ,
	142	 ,
	148	 ,
	148	 ,
	154	 ,
	160	 ,
	160	 ,
	166	 ,
	172	 ,
	178	 ,
	178	 ,
	184	 ,
	190	 ,
	202	 ,
	208	 ,
	214	 ,
	220	 ,
	232	 ,
	238	 ,
	250	 ,
	262	 ,
	274	 ,
	286	 ,
	298	 ,
	310	 ,
	328	 ,
	346	 ,
	364	 ,
	382	 ,
	400	 ,
	424	 ,
	442	 ,
	466	 ,
	496	 ,
	526	 ,
	556	 ,
	586	 ,
	622	 ,
	658	 ,
	658	 ,
	658	 ,
	658	 ,
	658	 
};

void gpio_init(void);
uint8  startMotor(void);
float get_speed(void);